// Blogosphere Browser 0.1
// Patrick Meister, Juni 2006


class Post {

  Posts elternBaum;                       // Posts objekt fr die eltern dieses Posts
  Posts kinderBaum;                       // Posts objekt fr die kinder deises Posts
  Posts postsRef;                         // Referenz zum Posts-objekt (wird nicht hier erstellt!!!!!!!!!!)
  Particle linkesPartikel;                // Partikel, das den linken Rand bestimmt
  Particle rechtesPartikel;               // Partikel, das den rechten Rand bestimmt
  Spring meineSpring;                     // Spring-Objekt dieses Posts
  Attraction meineAttraction;             // Attraction-Objekt dieses Posts
  Vector3D startPunkt;                    // Startpunkt fr dieses Post
  int anzahlAntworten;                    // Anzahl Antworten auf dieses Post (zufllig)
  int anzahlEltern;                       // Anzahl eltern dieses posts (zufllig)
  
  
  Gradient verlauf;
  int[] verlaufsFarben;

  float springLength = 3;
  float springStrength = .3;
  float springDamping = .2;
  float attractionStrength = 10;
  float breite;
  float hoehe;
  float alteHoehe;                   // alte hohe speichern, um vernderungen festzustellen und gezielt den verlauf neu zu berechnen
  float originalHoehe;               // speichert die geschlossene hohe dieses posts
  float ersteVergroesserung = 20;
  int altersNr;                      // speichert, der wievielte post dieser post in der reihe ist
  int anzahlPostsInBaum;             // speichert die anzahl brder + 1 (anzahl posts in diesem (eltern-)baum
  
  Vector3D obenLinks;               // speichern die koordinaten der 4 ecken
  Vector3D obenRechts;
  Vector3D untenLinks;
  Vector3D untenRechts;
  
  float globalMouseX;
  float globalMouseY;

  String titel;
  String inhalt;
  String metaDaten;

  boolean overKlick = false;
  boolean postOffen = false;
  boolean artVertikal = true;         // Art dieses Posts: false nach oben, true nach unten
  boolean baumArt;                    // Art des Baumes dieses Posts:  true = kinder, false = eltern
  color postFarbe1;                  // Farbe 1 fr den Verlauf
  color postFarbe2;                  // Farbe 2 fr den Verlauf
  color textFarbeZu;                  // Farbe fr den preview text
  color textFarbeOffen;              // Farbe fr den Text, wenn der Post aufgeklappt ist
  color titelFarbeZu;                // Farbe fr den mouse-over Titel
  color titelFarbeOffen;                  // Farbe fr den Titel in offenen posts

  boolean ichHabDenKlick;
  float relevanz;

  ////////////////////////////////////////////////
  // KONSTRUKTOR
  ////////////////////////////////////////////////
  Post( Vector3D _startPunkt, boolean _baumArt, int _altersNr, int _anzahlPostsInBaum) {
    startPunkt = _startPunkt;
    baumArt = _baumArt;
    altersNr = _altersNr;
    anzahlPostsInBaum = _anzahlPostsInBaum;
    anzahlAntworten = int(random(0,20));
    anzahlEltern = int(random(2,6));
    partikelErstellen();
    titel = beispielTitel[int(random(beispielTitel.length))];
    inhalt = beispielTexte[int(random(beispielTexte.length))];
    metaDaten = beispielMetaDaten[int(random(beispielMetaDaten.length))];
    hoehe = 10+1.5*anzahlAntworten;
    originalHoehe = hoehe;
    alteHoehe = hoehe;
    
    ichHabDenKlick = false;
    
    // Relevanz zufllig bestimmen. Die Posts sollen eher einen Hang zur Relevanz als zur nicht-relevanz haben...
    // daher die Schlaufe, die den random n-mal ausfhrt, und jeweils den grssten wert auswhlt
    for (int i = 0; i < 3; i++) {
      float neueRelevanz = random(0,30);
      relevanz = max(relevanz, neueRelevanz);
    }
    
    obenLinks = new Vector3D();
    obenRechts = new Vector3D();
    untenLinks = new Vector3D();
    untenRechts = new Vector3D();
    
    // Farben bestimmen, je nach baum-art anders
    if (baumArt) {
      // dieser Post is in einem Kinderbaum
      
      //postFarbe1 = color(30+(170/30)*relevanz, 30+(170/30)*relevanz,30+(170/30)*relevanz);
      //postFarbe2 = color(red(postFarbe1)-75, green(postFarbe1), blue(postFarbe1)+50);
      postFarbe1 = color(20+(160/30)*relevanz, 20+(160/30)*relevanz,20+(160/30)*relevanz);
      postFarbe2 = color(red(postFarbe1)-80, green(postFarbe1), blue(postFarbe1)+25);
      textFarbeZu = color(255,255, 255, 255 );
      textFarbeOffen = color(255,255, 255, 255 );
      titelFarbeZu = color(red(postFarbe2), green(postFarbe2), blue(postFarbe2), 220);
      titelFarbeOffen = color(255,255, 255, 230);

    } else {
      // dieser post ist in einem elternbaum
      //postFarbe1 = color((220/30)*relevanz, (170/30)*relevanz,(170/30)*relevanz);
      //postFarbe2 = color(red(postFarbe1)+175, green(postFarbe1), blue(postFarbe1)-150);
      postFarbe1 = color((220/30)*relevanz, (170/30)*relevanz,(170/30)*relevanz);
      postFarbe2 = color(red(postFarbe1)+150, green(postFarbe1), blue(postFarbe1)-100);
      textFarbeZu = color(255,255, 255, 255 );
      textFarbeOffen = color(255,255, 255, 255 );
      titelFarbeZu = color(red(postFarbe2), green(postFarbe2), blue(postFarbe2), 220);
      titelFarbeOffen = color(255,255, 255, 230);
    }
    // den verlauf erstmalig erstellen
    verlaufErstellen();
    
  }


  ////////////////////////////////////////////////
  // LOOP
  //
  // Wir in jedem Frame wiederholt. wird vom ber-
  // geordneten Post-Objekt aufgerufen
  ////////////////////////////////////////////////
  void run() 
  {
     errechneEckenUndMaus();
     if ((obenLinks.x*smoother.z() < width-smoother.x()*smoother.z()) && (obenLinks.y*smoother.z()  < height-smoother.y()*smoother.z()) && (untenLinks.y > 0-smoother.y() ) && (obenRechts.x > 0-smoother.x()) ) {

      // nur die partikel zeichnen, die sich im sichtfeld befinden
     
      breite = obenRechts.x - obenLinks.x;
      zeichneRepraesentant();
    // MOUSE OVER
    //
    if (mousePressed && !keyPressed) {
      // die Maus ist gedrckt
      if (overKlick == false ) {
        // die Maus war im letzten Frame NICHT ber dem Post
        if (over()&& (ichHabDenKlick || klickAktiv)) {
          // ich bin neu ber dem Post (ROLLOVER)  
          overKlick = true;
          if (postOffen == false) {
            // der Post ist nicht offen, also das ding aufschwabbeln
            meineSpring.setRestLength(40);
            hoehe = originalHoehe + ersteVergroesserung;

          }
        } 
        else {
          // ich bin immernoch nicht ber dem Post
          // rckbau -> falls ich noch mousePressed bin, aber nicht mehr ber dem Post, muss dieser trotzem schrumpfen  
          postSchrumpft();
          ichHabDenKlick = false;
          if (postOffen) {
            zeichneText();
            zeichneTitel();
          }
        }
      } 
      else {
        // die Maus war im letzten Frame ber dem Post
        if (globalMouseX < obenLinks.x || globalMouseX > obenRechts.x) {
          // ich bin auf der X-Achse ausserhalb des Posts
          // 
          overKlick = false;
          ichHabDenKlick = false;
          klickAktiv = true;
          postSchrumpft();
          println("jetzt");
        } 
        else {
          // ich bin auf der X-Achse noch INNERHALB des Posts  
          if ((globalMouseY > (linkesPartikel.position().y() + (originalHoehe + ersteVergroesserung)/2))  && (ichHabDenKlick || klickAktiv)) {
          //if (globalMouseY > untenLinks.y) {
            //if (mouseY > linkesPartikel.position().y() + hoehe) {
            //Die Maus wurde nach UNTEN gezogen
            // also die hoehe anpassen
            // ich bin nach unten aufgezogen  
            artVertikal = true;
            postOffen = true;
            hoehe = globalMouseY - obenLinks.y;
            klickAktiv = false;
            ichHabDenKlick = true;
            
            meineSpring.setRestLength(200);
            
            zeichneText();
            zeichneTitel();
            // hier die 2 weiteren Posts-objekte erstellen, falls sie noch nicht existieren
            kinderElternErstellen();
            //translationUpdaten();
          }
          else if ((globalMouseY < (linkesPartikel.position().y() - (originalHoehe + ersteVergroesserung)/2)) && (ichHabDenKlick || klickAktiv)) {
            //Die Maus wurde nach OBEN gezogen
            // also die hoehe anpassen  
            // der post ist nach oben aufgezogen
            artVertikal = false;
            postOffen = true;
            hoehe =  untenLinks.y - globalMouseY;
            
            meineSpring.setRestLength(200);
            zeichneText();
            zeichneTitel();
            // hier die 2 weiteren Posts-objekte erstellen, falls sie noch nicht existieren
            kinderElternErstellen();
            klickAktiv = false;
            ichHabDenKlick = true;
          } 
          else {
            // Die Maus ist geklickt ber dem Post, aber NICHT nach unten gezogen
            // Also den Post nur ein wenig aufspannen (rollover-mssig)
            meineSpring.setRestLength(40);
            hoehe = originalHoehe + ersteVergroesserung;
            postOffen = false;
            artVertikal = true;
            //ichHabDenKlick = false;
            //println("zu");
            zeichneText();
            zeichneLinie();
            zeichneTitel();
            if (kinderBaum != null) {
              // falls ich schon kinder/eltern habe, diese hier lschen
              kinderBaum.kill();
              elternBaum.kill(); 
              kinderBaum = null;
              elternBaum = null; 
              
              // dem PostS-Objekt mitteilen, dass ein Post weniger offen ist
             postsRef.updateOffenePosts(-1);
            }
          }
        }  
      }
    } 
    else {
      // die Maus ist nicht gedrckt. 
      if (postOffen) {
        zeichneText();
        zeichneTitel();
      }
      overKlick = false; // ntig?! 
      postSchrumpft();
      //ichHabDenKlick = false;
    }

    }

    if (kinderBaum != null) {
      kinderElternVerschieben();
      kinderBaum.run();
      elternBaum.run();

    }
    
    if (hoehe != alteHoehe) {
      // nur wenn sich die hoehe gendert hat, einen neuen verlauf erstellen (performance!)
     verlaufErstellen(); 
    }
    alteHoehe = hoehe;
    }
  


  void partikelErstellen() { 
    // Ein neues Partikel erstellen, und es mit Spring und Attraction ausrsten
    linkesPartikel = physics.makeParticle();
    rechtesPartikel = physics.makeParticle();
    fill(200,0,9);
    //ellipse(startPunkt.x, startPunkt.y, 10, 10);
    postSpring( linkesPartikel, rechtesPartikel );              // eine Spring (Feder) hinzufgen
    //postAttraction( linkesPartikel, rechtesPartikel );        // eine Attraction hinzufgen

    linkesPartikel.moveTo( startPunkt.x, startPunkt.y+hoehe, 0 );     // das neue Partikel an einen Startplatz verschieben
    rechtesPartikel.moveTo( startPunkt.x , startPunkt.y+hoehe, 0);
  }



  void postAttraction( Particle p, Particle r ) {
    for ( int i = 0; i < physics.numberOfParticles(); ++i )
    {
      Particle q = physics.getParticle( i );
      if ( p != q && p != r ) {
        meineAttraction = physics.makeAttraction( p, q, -attractionStrength, 0 );
      }
    }
  }


  void postSpring( Particle a, Particle b ) {
    meineSpring = physics.makeSpring( a, b, springStrength, springDamping, springLength );
  }
  
  
  
  void zeichneLinie() 
    // zeichnet die kleine Linie zwischen Post und Titel
  {
    strokeWeight(0.5);
    stroke(postFarbe2);
    line(obenLinks.x + breite/2, obenLinks.y, obenLinks.x + breite/2, obenLinks.y-20);
  }






  void zeichneTitel() 
    // Zeichnet den Titel des aktiven Posts
  {

    if (postOffen) {
      fill(titelFarbeOffen);
      textFont(fontTitelOffen, 18);
      //textSize(16);
      //float textBreite = textWidth(titel);
      float textHoehe = textAscent() + textDescent();
      float feldBreite = breite - 10;

      text(titel, obenLinks.x +5, obenLinks.y + 5, feldBreite, textHoehe);
      
    } 
    else {
      fill(titelFarbeZu);
      textFont(fontTitelZu, 30);
      float textBreite = textWidth(titel);
      text(titel, obenLinks.x + breite/2 - textBreite/2, obenLinks.y - 20);  
    }
  }



  void zeichneText()
    // Zeichnet den Text des Posts
  {
    
    if (postOffen) {
      
      fill(textFarbeOffen);
      textFont(fontMeta, 9);
      text(metaDaten, obenLinks.x + 5, obenLinks.y + 25, breite-10, 40);
      if (hoehe - 80 > 0) {
        textFont(fontInhaltOffen, 9);
        text(inhalt, obenLinks.x + 5, obenLinks.y + 70, breite-15, hoehe-80);
      }
    } 
    else {
      textFont(fontInhaltZu, 8);
      fill (textFarbeZu);
      text(inhalt, obenLinks.x + 5, obenLinks.y +5, breite-10, hoehe-10);
    }
  }





  void zeichneRepraesentant() 
    // Darstellung des Posts selbst (rechtecke)
  {
    noStroke();
    fill(postFarbe1);

    if (artVertikal) {
      // nach UNTEN
      for(int y=0; y<int(verlaufsFarben.length); y++) {
        // die gradient-klasse kann nicht sauber mit transparenzen umgehen... daher wird hier die transparenz hinzugefgt
        color farbeTrans = color(red(verlaufsFarben[y]), green(verlaufsFarben[y]), blue(verlaufsFarben[y]), 200);
        fill(farbeTrans);
        // auch bei linien gibt es probleme mit den transparenzen... daher wird ein rect mit der hoehe 1 verwendet
        rect( int(obenLinks.x), int(obenLinks.y + y), int(breite) , 1 ); 
      }
    } else {
      // nach OBEN 
      for(int y=verlaufsFarben.length-1; y>0; y--) {
        // die gradient-klasse kann nicht sauber mit transparenzen umgehen... daher wird hier die transparenz hinzugefgt
        color farbeTrans = color(red(verlaufsFarben[y]), green(verlaufsFarben[y]), blue(verlaufsFarben[y]), 200);
        fill(farbeTrans);
        // auch bei linien gibt es probleme mit den transparenzen... daher wird ein rect mit der hoehe 1 verwendet
        rect( int(obenLinks.x), int(obenLinks.y+y), int(breite) , 1 ); 
      }
    }
  }





  void postSchrumpft()
    // Normalisiert die Grsse des Posts, falls der Post nicht gerade offen ist
    
  {
    if (postOffen == false) {
      if (meineSpring.restLength() > springLength) {
        float rest = (meineSpring.restLength() - springLength) / 10;
        meineSpring.setRestLength(meineSpring.restLength()-rest);
      }

      if (hoehe > originalHoehe) {   
        hoehe = hoehe - (hoehe - originalHoehe) /10;  

      }
    }
  }




  void errechneEckenUndMaus() {
    // Errechnet aus der hohe und der position der partikel die koordinaten der 4 Ecken des posts
    
    if (postOffen) {
     // der Post ist OFFEN, also berprfen, in welche richtung
    
      if (artVertikal) {
         // ich bin nach UNTEN offen
         obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-(originalHoehe+ersteVergroesserung)/2, 0);
         obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-(originalHoehe+ersteVergroesserung)/2, 0);
         untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+ hoehe - (originalHoehe+ersteVergroesserung)/2, 0);
         untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+ hoehe - (originalHoehe+ersteVergroesserung)/2, 0);
      } else {
         // ich bin nach OBEN offen
         obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-hoehe + (originalHoehe+ersteVergroesserung)/2, 0);
         obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-hoehe + (originalHoehe+ersteVergroesserung)/2, 0);
         untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+(originalHoehe+ersteVergroesserung)/2, 0);
         untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+(originalHoehe+ersteVergroesserung)/2, 0);
      } 
    } else {
      // der post ist ZU, also einfach einmitten
       obenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()-hoehe/2, 0);
       obenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()-hoehe/2, 0);
       untenLinks.setXYZ(linkesPartikel.position().x(), linkesPartikel.position().y()+hoehe/2, 0);
       untenRechts.setXYZ(rechtesPartikel.position().x(), rechtesPartikel.position().y()+hoehe/2, 0);
    }
    
    // Debugging:
    /*
    fill(255, 150);
    noStroke();
    ellipse(obenLinks.x, obenLinks.y, 5, 5);
    ellipse(obenRechts.x, obenRechts.y, 5, 5);
    ellipse(untenLinks.x, untenLinks.y, 5, 5);
    ellipse(untenRechts.x, untenRechts.y, 5, 5);
    
    
        fill(255, 150);
    noStroke();
    ellipse(obenLinks.x-(smoother.z()*smoother.x()), obenLinks.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(obenRechts.x-(smoother.z()*smoother.x()), obenRechts.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(untenLinks.x-(smoother.z()*smoother.x()), untenLinks.y-(smoother.z()*smoother.y()), 5, 5);
    ellipse(untenRechts.x-(smoother.z()*smoother.x()), untenRechts.y-(smoother.z()*smoother.y()), 5, 5);
    
    fill(255,0,0);
    ellipse(mouseX/smoother.z() - smoother.x(), mouseY/smoother.z() - smoother.y(), 5, 5);
    */
    globalMouseX = mouseX/smoother.z() - smoother.x();
    globalMouseY = mouseY/smoother.z() - smoother.y();
  }
  
  
  

  boolean over()
    // Gibt true zurck, wenn sich der Mauspointer auf dem Post befindet. Sonst false.
  {
      if (globalMouseX  >= obenLinks.x && globalMouseX <= obenRechts.x &&
        globalMouseY >=  obenLinks.y && globalMouseY <=  untenLinks.y) {
        println("drin");  
        return true;
      } 
      else {
        return false;  
      }
  }
  
  
  
  
  void verlaufErstellen() {
    verlauf = null;
    verlauf = new Gradient();

    verlauf.addColor(0,postFarbe1);
    verlauf.addColor(int(hoehe),postFarbe2);
    verlaufsFarben = verlauf.calcGradient(0,int(hoehe)); 
  }





  void kinderElternErstellen()
    // erstellt die kinder und eltern bume
  {
    if (kinderBaum == null && anzahlAntworten > 0) {
      // dem PostS-objekt mitteilen, dass ein neues Ding offen ist.
     postsRef.updateOffenePosts(1);
      
      Vector3D start = new Vector3D();
      Vector3D ende = new Vector3D();
      if (artVertikal) {
        // bin nach UNTEN aufgezogen
        start.setXYZ(untenRechts.x, untenRechts.y, 0);
        ende.setXYZ(untenRechts.x + anzahlAntworten*25, untenRechts.y, 0);
      } 
      else {
        // bin nach oben aufgezogen
        start.setXYZ(obenRechts.x, obenRechts.y, 0);
        ende.setXYZ(obenRechts.x + anzahlAntworten*25, obenRechts.y, 0);
      }
      kinderBaum = new Posts(start, ende, anzahlAntworten, true);

      if (artVertikal) {
        // bin nach UNTEN aufgezogen
        start.setXYZ(untenLinks.x - anzahlEltern*25, untenLinks.y, 0);
        ende.setXYZ(untenLinks.x, untenLinks.y, 0);
      } 
      else {
        // bin nach oben aufgezogen
        start.setXYZ(obenLinks.x - anzahlEltern*25, obenLinks.y, 0);
        ende.setXYZ(obenLinks.x , obenLinks.y, 0);
      }

      elternBaum = new Posts(start, ende, anzahlEltern, false);
    } 
  }
  
  
  
  

  void kinderElternVerschieben()
    // verschiebt die Ankerpunkte der eltern und kinder-bume
  {
    float verrechnungY;
    if (artVertikal) {
      // nach UNTEN offen
      kinderBaum.sollSystemStart.setXYZ(untenRechts.x, untenLinks.y, 0);
      elternBaum.sollSystemEnd.setXYZ(untenLinks.x, untenRechts.y, 0);
    } else {
      // nach OBEN offen
      kinderBaum.sollSystemStart.setXYZ(obenRechts.x, obenRechts.y, 0);
      elternBaum.sollSystemEnd.setXYZ(obenLinks.x, obenLinks.y, 0);
    }
  }






  public void postsRef(Posts _postsRef) {
    // wird vom Posts-objekt aufgerufen, dass diesen Post erstellt hat 
    // macht diesem Post das PostS-objetkt bekannt
     postsRef = _postsRef; 
    // println(postsRef.springLength);
  }





  void mouseReleased() 
  {
    overKlick = false; 
  }





  void kill() 
    // lscht die Partikel dieses Posts
  {
    linkesPartikel.kill();
    rechtesPartikel.kill();
    if (kinderBaum != null) {
      kinderBaum.kill();
      elternBaum.kill(); 
      kinderBaum = null;
      elternBaum = null;
    }
  }

}


